//+------------------------------------------------------------------+
//|                                           Volatility quality.mq4 |
//|                                                                  |
//|                                                                  |
//| Volatility quality index originaly developed by                  |
//| Thomas Stridsman (August 2002 Active Trader Magazine)            |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     Orange
#property indicator_color2     OrangeRed
#property indicator_color3     DeepSkyBlue
#property indicator_color4     DeepSkyBlue
#property indicator_width1     2
#property indicator_width2     1
#property indicator_width3     2
#property indicator_width4     1
#property indicator_minimum    0
#property indicator_maximum    1
//
//
//
//
//

extern string TimeFrame                 = "Current time frame";
extern double PriceSmoothing            = 21;
extern int    PriceSmoothingMethod      = MODE_LWMA;
extern double Filter                    = 0;
extern double MaPeriod                  = 15;
extern int    MaMethod                  = MODE_LWMA;
extern int    ColoringMode              = 0;
extern bool   alertsOn                  = true;
extern bool   alertsOnCurrent           = true;
extern bool   alertsMessage             = true;
extern bool   alertsSound               = true;
extern bool   alertsNotification        = true;
extern bool   alertsEmail               = false;

//
//
//
//
//

double Upa[];
double Upb[];
double Dna[];
double Dnb[];
double sumVqi[];
double trend[];
double slope[];
double ma[];

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
string shortName;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
  {
   IndicatorBuffers(8);
      SetIndexBuffer(0,Dna);   SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,Dnb);   SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,Upa);   SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,Upb);   SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,sumVqi); 
      SetIndexBuffer(5,ma);   
      SetIndexBuffer(6,trend); 
      SetIndexBuffer(7,slope);
      SetLevelValue(0,0); 
      SetIndexEmptyValue(4,0.0);
      PriceSmoothing = MathMax(PriceSmoothing,1);
        
        //
        //
        //
        //
        //
      
        indicatorFileName = WindowExpertName();
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        timeFrame = stringToTimeFrame(TimeFrame);
      
        //
        //
        //
        //
        //
      
   shortName = ""+timeFrameToString(timeFrame)+" RP";
   IndicatorShortName(shortName);
return(0);
}

//
//
//
//
//

int deinit() 
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double Vqi[];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Dna[0] = limit+1; return(0); }
         
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {         
      if (ArraySize(Vqi)!= Bars) ArrayResize(Vqi,Bars);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         if (i==(Bars-1))
         {
            Vqi[r]    = 0;
            sumVqi[i] = 0;
            continue;
         }
      
         //
         //
         //
         //
         //
      
         double cHigh  = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_HIGH ,i);
         double cLow   = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_LOW  ,i);
         double cOpen  = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_OPEN ,i);
         double cClose = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_CLOSE,i);
         double pClose = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_CLOSE,i+1);

         double trueRange = MathMax(cHigh,pClose)-MathMin(cLow,pClose);
         double     range = cHigh-cLow;
      
            if (range != 0 && trueRange!=0)
               double vqi = ((cClose-pClose)/trueRange + (cClose-cOpen)/range)*0.5;
            else      vqi = Vqi[r-1];

      //
      //
      //
      //
      //
         
         Vqi[r]    = MathAbs(vqi) * (cClose - pClose+cClose - cOpen) * 0.5;
         sumVqi[i] = Vqi[r];
            if (Filter > 0) if (MathAbs(sumVqi[i] - sumVqi[i+1]) < Filter * Point) sumVqi[i] = sumVqi[i+1];
      
      //
      //
      //
      //
      //
      
      trend[i] = trend[i+1];
      slope[i] = slope[i+1];
          
          if (sumVqi[i] > sumVqi[i+1]) slope[i] =  1;
          if (sumVqi[i] < sumVqi[i+1]) slope[i] = -1;
               
      }
      for(i=limit; i>=0; i--)
      {
         ma[i]  = iMAOnArray(sumVqi,0,MaPeriod,0,MaMethod,i);
         Dna[i] = EMPTY_VALUE;
         Dnb[i] = EMPTY_VALUE;
         Upa[i] = EMPTY_VALUE;
         Upb[i] = EMPTY_VALUE;
            if (sumVqi[i] > ma[i]) trend[i] =  1;
            if (sumVqi[i] < ma[i]) trend[i] = -1;
            if (ColoringMode==1)
            {
               if (sumVqi[i]>0 && sumVqi[i]>ma[i]) { Upa[i] = 1; continue; }
               if (sumVqi[i]>0)                    { Upb[i] = 1; continue; }
               if (sumVqi[i]<0 && sumVqi[i]<ma[i]) { Dna[i] = 1; continue; }
               if (sumVqi[i]<0)                    { Dnb[i] = 1; continue; }
               continue;
            }
            if (sumVqi[i]>0 && sumVqi[i]>ma[i] && slope[i]==1)  { Upa[i] = 1; continue; }
            if (sumVqi[i]>0)                                    { Upb[i] = 1; continue; }
            if (sumVqi[i]<0 && sumVqi[i]<ma[i] && slope[i]==-1) { Dna[i] = 1; continue; }
            if (sumVqi[i]<0)                                    { Dnb[i] = 1; continue; }
      }         
      manageAlerts();
      return(0);
   }   
      
   //
   //
   //
   //
   //
     
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         Dna[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,Filter,MaPeriod,MaMethod,ColoringMode,0,y);
         Dnb[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,Filter,MaPeriod,MaMethod,ColoringMode,1,y);
         Upa[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,Filter,MaPeriod,MaMethod,ColoringMode,2,y);
         Upb[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,Filter,MaPeriod,MaMethod,ColoringMode,3,y);
         trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,Filter,MaPeriod,MaMethod,ColoringMode,6,y);
   }
   manageAlerts();
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] == 1) doAlert(whichBar,"Crossed average Up");
            if (trend[whichBar] ==-1) doAlert(whichBar,"Crossed average Down");
         }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," VQ ",doWhat);
             if (alertsMessage)      Alert(message);
             if (alertsEmail)        SendMail(StringConcatenate(Symbol(),"VQ"),message);
             if (alertsNotification) SendNotification(message);
             if (alertsSound)        PlaySound("VolatilityQuality.wav");
      }
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//

string sTfTable[] = { "M1","M5","M15","M30","H1","H4","D1","W1","MN" };
int    iTfTable[] = { 1,5,15,30,60,240,1440,10080,43200 };

//
//
//
//
//

int stringToTimeFrame(string tfs) {
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf) {
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str) {
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--) {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}      
      
      
   


